﻿# fuelle-Schritt-1-Kurs.py    ## Version mit tiefer Liste
# schrittweise Erarbeitung:
# rekursives Programm zum Füllen eines Containers mit greedy
# Problem der Rekursionstiefe beachten!

# Schritt / Fall 0:
# Klärung der Aufgabe
# Globale Variable für die Stücke:
stuecke=[30,30,30,20,20,20,20]

def ist_voll(container):
    '''prüft, ob der Container vollständig gefüllt ist'''
    return container[0]==sum(container[1])

# Erarbeitung des Funktionskopfes
# - stuecke s.o.
# - Container ist eine zunächst leere Liste
def fuelle(stuecke, container):
    if ist_voll(container):
        return container
    return 'kann noch nichts'

## Tests:
print( stuecke, 80, 'Ergebnis: ', fuelle(stuecke, [80, [30,30,20]])) # Erfolg
##print( stuecke, 80, 'Ergebnis: ', fuelle(stuecke, [80, [30,30]])) # wird zu voll
##print( [], 80, 'Ergebnis: ', fuelle([], [80, []])) # Misserfolg
##print( stuecke, 80, 'Ergebnis: ', fuelle(stuecke, [80, []]))
