﻿# fuelle-Schritt-3-Kurs.py    ## Version mit tiefer Liste
# schrittweise Erarbeitung:
# rekursives Programm zum Füllen eines Containers mit greedy
# Problem der Rekursionstiefe beachten!

# Schritt / Fall 0:
# Klärung der Aufgabe
# Globale Variable für die Stücke:
stuecke=[30,30,30,20,20,20,20]

def ist_voll(container):
    '''prüft, ob der Container vollständig gefüllt ist'''
    return container[0]==sum(container[1])

def wird_zu_voll(stueck, container):
    '''prüft, ob der Container mit den Stück zu voll wird'''
    return stueck+sum(container[1])>container[0]

def einladen(stueck, container):
    '''lädt das Stück in den Container ein'''
    return [container[0], container[1]+[stueck]]

# Erarbeitung des Funktionskopfes
# - stuecke s.o.
# - Container ist eine zunächst leere Liste
def fuelle(stuecke, container):
    if ist_voll(container):
        ## passt genau
        return container
    elif wird_zu_voll(stuecke[0], container):
        ## passt nicht
        return fuelle(stuecke[1:], container)
    else:
        ## passt rein (Normalfall)
        return fuelle(stuecke[1:] , einladen(stuecke[0], container))

## Tests:
print( stuecke, 80, 'Ergebnis: ', fuelle(stuecke, [80, [30,30,20]])) # Erfolg
print( stuecke, 80, 'Ergebnis: ', fuelle(stuecke, [80, [30,30]])) # wird zu voll
print( [], 80, 'Ergebnis: ', fuelle([], [80, []])) # Misserfolg
print( stuecke, 80, 'Ergebnis: ', fuelle(stuecke, [80, []]))
